#ifndef BMI160_H
#define BMI160_H

#include <stdint.h>
#include "user_define.h"
#include "bmi160.h"

#if defined(USE_BMI160)

void print_bmi160_rslt(int8_t rslt);

#if defined(FIFO_POLL) || defined(FIFO_WM_INT)
int8_t Open_BMI160_FIFO(struct bmi160_dev *dev);
int8_t Close_BMI160_FIFO(struct bmi160_dev *dev);
#endif

#if defined(STEP_COUNTER)
int8_t Open_BMI160_STEP_COUNTER(struct bmi160_dev *dev);
int8_t Close_BMI160_STEP_COUNTER(struct bmi160_dev *dev);
#endif

#if defined(STEP_DETECTOR)
int8_t Open_BMI160_STEP_DETECTOR(struct bmi160_dev *dev);
int8_t Close_BMI160_STEP_DETECTOR(struct bmi160_dev *dev);
#endif

#if defined(TAP)
int8_t Open_BMI160_TAP(struct bmi160_dev *dev);
int8_t Close_BMI160_TAP(struct bmi160_dev *dev);
#endif

#if defined(ANY_MOTION)
int8_t Open_BMI160_ANY_MOTION(struct bmi160_dev *dev);
int8_t Close_BMI160_ANY_MOTION(struct bmi160_dev *dev);
#endif

#if defined(NO_MOTION)
int8_t Open_BMI160_NO_MOTION(struct bmi160_dev *dev);
int8_t Close_BMI160_NO_MOTION(struct bmi160_dev *dev);
#endif

#if defined(SIG_MOTION)
int8_t Open_BMI160_SIG_MOTION(struct bmi160_dev *dev);
int8_t Close_BMI160_SIG_MOTION(struct bmi160_dev *dev);
#endif


#if defined(ORIENTATION)
int8_t Open_BMI160_ORIENTATION(struct bmi160_dev *dev);
int8_t Close_BMI160_ORIENTATION(struct bmi160_dev *dev);
#endif

#if defined(FLAT_DETECTION)
int8_t Open_BMI160_FLAT_DETECTION(struct bmi160_dev *dev);
int8_t Close_BMI160_FLAT_DETECTION(struct bmi160_dev *dev);
#endif

#if defined(LOW_G)
int8_t Open_BMI160_LOW_G(struct bmi160_dev *dev);
int8_t Close_BMI160_LOW_G(struct bmi160_dev *dev);
#endif

#if defined(HIGH_G)
int8_t Open_BMI160_HIGH_G(struct bmi160_dev *dev);
int8_t Close_BMI160_HIGH_G(struct bmi160_dev *dev);
#endif

#if defined(FOC)
int8_t Start_BMI160_FOC(struct bmi160_dev *dev);
int8_t Stop_BMI160_FOC(struct bmi160_dev *dev);
#endif

#if defined(FIFO_POLL) || defined(STEP_COUNTER)
void BMI160_Timer_Callback(TimerHandle_t xTimer);
#endif

#if defined(STEP_DETECTOR) || defined(TAP) || defined(ANY_MOTION) || defined(NO_MOTION) || defined(FLAT_DETECTION) || defined(ORIENTATION) || defined(HIGH_G) || defined(LOW_G)
void StartBMI160InterruptTask(void const * argument);
#endif

int8_t Init_BMI160(struct bmi160_dev *dev);
void StartBMI160Task(void const * argument);

#endif
#endif
